# DGS1 - nur die GUI

from SWGui import *
initSWGui()

buttonFrame=SWFrameHori() # Ein Container fuer die Buttons
bZug=SWButton(container=buttonFrame,text="Zugmodus")
bPunkt=SWButton(container=buttonFrame,text="Punkt")
bMP=SWButton(container=buttonFrame,text="MP")
bSchnitt=SWButton(container=buttonFrame,text="Schnittpunkt")
bGerade=SWButton(container=buttonFrame,text="Gerade")
bLot=SWButton(container=buttonFrame,text="Lot")
bParallele=SWButton(container=buttonFrame,text="Parallele")
bKreis=SWButton(container=buttonFrame,text="Kreis")
message=SWLabel(container=buttonFrame,text="")
message.setWidth(22)

zeichenflaeche=SWCanvas(width=400,height=400)

modus="Punkt" # Jeweils aktueller Modus des Programms
def setMode(m,hilfetext):
    global modus,message 
    modus=m
    message.setText(hilfetext)
    
def zugModus(): setMode("Zug","Zugmodus")
def punktModus():setMode("Punkt","Punkt erzeugen")
def MPModus(): setMode("MP","Mittelpunkt")
def schnittModus(): setMode("Schnitt","Schnittpunkt")
def geradeModus(): setMode("Gerade","Gerade")
def lotModus(): setMode("Lot","Lot")
def paralleleModus(): setMode("Parallele","Parallele")
def kreisModus(): setMode("Kreis","Kreis")
bZug.setCommand(zugModus)  # Buttons mit Funktion versehen
bPunkt.setCommand(punktModus)
bMP.setCommand(MPModus)
bSchnitt.setCommand(schnittModus)
bGerade.setCommand(geradeModus)
bLot.setCommand(lotModus)
bParallele.setCommand(paralleleModus)
bKreis.setCommand(kreisModus)

# Hilfsfunktionen, die zwischen mathematischen Koordinaten
# und Bildschirm-Koordinaten umrechnen

ausschnitt={"xmin":-10.0,"xmax":10.0,"ymin":-10.0,"ymax":10.0}

def welt2schirm(co):
    global ausschnitt,zeichenflaeche
    a=ausschnitt
    [xw,yw]=co
    [w,h]=zeichenflaeche.getDim()
    sc=[w*(xw-a["xmin"])/(a["xmax"]-a["xmin"]),
        h*(1-(yw-a["ymin"])/(a["ymax"]-a["ymin"]))]
    return map(int,sc)

def schirm2welt(co):
    global ausschnitt,zeichenflaeche
    a=ausschnitt
    [xs,ys]=co
    [w,h]=zeichenflaeche.getDim()
    return [a["xmin"]+(a["xmax"]-a["xmin"])*xs/float(w),
            a["ymin"]+(a["ymax"]-a["ymin"])*(1-ys/float(h))]

def klick(event):
    global modus
    co=schirm2welt([event.x,event.y])
    print "Klick bei ", co
    if modus=="Punkt": erzeugePunkt(co)

def drag(event):
    co=schirm2welt([event.x,event.y])
    print "Drag nach ", co
    
zeichenflaeche.setClickCommand(klick)
zeichenflaeche.setDragCommand(drag)

def erzeugePunkt(co): # Co ist Liste von Weltkoordinaten
    global zeichenflaeche
    [x,y]=welt2schirm(co)
    punkt=zeichenflaeche.createCircle(x,y,5)
    punkt.setColor("red")



