# Weg 1: Analogon des Beispiels mit Python-Klassen

import math

class Punkt:
    def __init__(self,x,y,z):
        self.x=x
        self.y=y
        self.z=z
    def Betrag(self):
        return math.sqrt(self.x**2+self.y**2+self.z**2)
    def Mittelpunkt(self,B):
        return Punkt((self.x+B.x)/2.0, (self.y+B.y)/2.0, (self.z+B.z)/2.0)
    def Beschreibe(self):
        return "["+str(self.x)+","+str(self.y)+","+str(self.z)+"]"


a=Punkt(1,2,3)
b=Punkt(2,0,7)
print "Beschreibe a ", a.Beschreibe()
print "Beschreibe b ", b.Beschreibe()
c=a.Mittelpunkt(b)
print "Mittelpunkt c von a und b", c.Beschreibe()
print "Betrag von c ", c.Betrag()

# Jetzt noch eine Farbklasse ------

class Farbe:
    def __init__(self,r,g,b):
        if r<0 or g<0 or b<0 or r>255 or g>255 or b>255:
            raise Exception("Falsche Farbwerte")
        self.r=int(r)
        self.g=int(g)
        self.b=int(b)
    def Betrag(self): return self.r+self.g+self.b
    def Beschreibe(self):
        return "Farbe("+str(self.r)+","+str(self.g)+","+str(self.b)+")"

f=Farbe(255,255,0)
print "Beschreibe f ", f.Beschreibe()
print "Betrag von f ", f.Betrag()

# Vererbung: Eine Klasse GeoPunkt erbt von Punkt

class GeoPunkt(Punkt):
    def __init__(self,name,x,y,z,r,g,b):
        Punkt.__init__(self,x,y,z)
        self.farbe=Farbe(r,g,b)
        self.name=name
    def Beschreibe(self):
        s="GeoPunkt "+self.name+"["+str(self.x)+","+str(self.y)+","+str(self.z)
        return s+"] Farbe="+self.farbe.Beschreibe()
    def setzeNamen(self,nam): self.name=nam

gp=GeoPunkt("Q",1,2,3,255,0,0)
print 
print gp.Beschreibe()
gp.setzeNamen("Q1")
print gp.Beschreibe()

